#include <iostream>
using namespace std;

class CPolygon {
  protected:
    int width, height;
  public:
    void set_values (int a, int b)
      { width=a; height=b; }
    // metodo virtual pode ser redefinido pelas
    // subclasses e utilizar polimorfismo
    virtual int area () {
       return 0; 
    }
};

class CRectangle: public CPolygon {
  public:
    int area ()
      { return (width * height); }
};

class CTriangle: public CPolygon {
  public:
    int area ()
      { return (width * height / 2); }
};

int main (int argc, char *argv[]) {
  CRectangle rect;
  CTriangle trgl;
  CPolygon * ppoly1 = &rect;
  CPolygon * ppoly2 = &trgl;
  ppoly1->set_values (4,5); // metodo herdado
  ppoly2->set_values (4,5); // metodo herdado

  // area foi definido para derivadas, preciso do ponteiro originao  
  cout << rect.area() << endl;
  cout << trgl.area() << endl;
  return 0;
}