#include <iostream>
using namespace std;

class CPolygon {
  protected:
    int width, height;
  public:
    void set_values (int a, int b) {
       width=a; height=b; 
    }
    // funcao virtual pura
    // Classe Abstrata eh uma classe que contem 
    // pelo menos uma funcao virtual
    // a classe nao pode mais ser instanciada
    virtual int area () = 0;
};

class CRectangle: public CPolygon {
  public:
    int area ()
      { return (width * height); }
};

class CTriangle: public CPolygon {
  public:
    int area ()
      { return (width * height / 2); }
};

int main (int argc, char *argv[]) {
  CRectangle rect;
  CTriangle trgl;
  //CPolygon poly; // erro pois CPolygon eh abstrata e nao pode ser instanciada
  CPolygon * ppoly1 = &rect;
  CPolygon * ppoly2 = &trgl;
  ppoly1->set_values (4,5); // metodo herdado
  ppoly2->set_values (4,5); // metodo herdado

  // area e virtual, e portanto
  cout << ppoly1->area() << endl;
  cout << ppoly2->area() << endl;
  return 0;
}