
class List {
    
  private:
      int maxsize;
    
  protected:
      typedef struct node {
	 int value;
	 struct node *next;
      } NODE;
      
      NODE *head;
      int size;
      
  public:
    
    List();
    List(int);
    List(const List &source);
    ~List();
    int isEmpty();
    int isFull();
    void insertBegin(int);
    void printList();
    List& operator=(const List&);    
};
